<ui:composition xmlns:g="http://www.ihe.net/gazelle"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:rich="http://richfaces.org/rich"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalform" styleClass="form-horizontal">
            <s:token allowMultiplePosts="true"/>
            <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                           value="#{assertionScopeManager.filter.urlParameters}"/>
            <script>
                updateUrl("globalform:filterUrlParameters");
                $("#globalform\\:filterUrlParameters").bind('change',
                        function () {
                            updateUrl("globalform:filterUrlParameters");
                        });

            </script>
            <div class="row">
                <div class="col-lg-3">
                    <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                        <ui:define name="panel_title">#{messages['net.ihe.gazelle.assertion-manager.ScopeFilter']}
                        </ui:define>
                        <div class="row">

                            <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                <ui:param name="id" value="scopeFilter"/>
                                <ui:define name="label">#{messages['net.ihe.gazelle.assertion-manager.Scope']}
                                </ui:define>
                                <h:selectOneMenu id="scopeFilter" styleClass="form-control gzl-select-text"
                                                 style="width: 90%;display: initial;"
                                                 value="#{assertionScopeManager.selectedScopeForFilter}">
                                    <s:selectItems var="scopeAvailable"
                                                   label="#{scopeAvailable}"
                                                   value="#{assertionScopeManager.getScopeNames()}"
                                                   noSelectionLabel="#{messages['gazelle.common.button.ShowAll']}"/>
                                    <a4j:ajax event="change" execute="@this"
                                              render="globalform"/>
                                </h:selectOneMenu>
                                <a4j:commandLink event="click"
                                                 actionListener="#{assertionScopeManager.resetSelectedScopeForFilter()}"
                                                 render="globalform" execute="@this">
                                    <span class="gzl-icon-times"/>
                                </a4j:commandLink>
                            </s:decorate>
                        </div>
                        <ui:define name="panel_footer">
                            <h:outputLink
                                    title="#{messages['net.ihe.gazelle.assertion-manager.NewScope']}"
                                    rendered="#{s:hasRole('admin_role')}"
                                    value="new.seam" styleClass="gzl-btn-green">
                                <f:param name="new" value="1"/>
                                <h:outputText
                                        value="#{messages['net.ihe.gazelle.assertion-manager.NewScope']}"/>
                            </h:outputLink>
                        </ui:define>
                    </ui:decorate>
                </div>
                <div class="col-lg-9">
                    <rich:dataTable rows="20" id="scopeTable" var="scopeCoverage"
                                    value="#{assertionScopeManager.getScopeCoverages()}"
                                    render="scopeTableDs">
                        <g:column id="scopeKeyword" sortBy="#{'scope.keyword'}"
                                  sortOrder="ascending">
                            <ui:define name="header">#{messages['net.ihe.gazelle.assertion-manager.Keyword']}
                            </ui:define>
                            <h:outputText value="#{scopeCoverage.scope.keyword}"/>
                        </g:column>
                        <g:column id="scopeDescription">
                            <ui:define name="header">#{messages['net.ihe.gazelle.simulators.Description']}</ui:define>
                            <h:outputText value="#{scopeCoverage.scope.description}"/>
                        </g:column>

                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.assertion-manager.TotalAssertions']}
                            </ui:define>
                            <h:outputLink
                                    title="#{scopeCoverage.scope.keyword} #{messages['net.ihe.gazelle.assertion-manager.Assertions']}"
                                    rendered="#{scopeCoverage.isDisplayActions()}"
                                    value="#{request.contextPath}/assertions/index.seam">
                                <f:param name="scope" value="#{scopeCoverage.scope.keyword}"/>
                                <h:outputText value="#{scopeCoverage.nbAssertionsForThisScope}"/>
                            </h:outputLink>
                            <h:outputText value="#{scopeCoverage.nbAssertionsForThisScope}"
                                          rendered="#{!scopeCoverage.isDisplayActions()}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">Not Testable</ui:define>
                            <h:outputLink
                                    title="Not testable assertions"
                                    rendered="#{scopeCoverage.isDisplayActions()}"
                                    value="#{request.contextPath}/assertions/index.seam">
                                <f:param name="scope" value="#{scopeCoverage.scope.keyword}"/>
                                <h:outputText value="#{scopeCoverage.nbAssertionsNotTestable}"/>
                            </h:outputLink>
                            <h:outputText value="#{scopeCoverage.nbAssertionsNotTestable}"
                                          rendered="#{!scopeCoverage.isDisplayActions()}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">
                                #{messages['net.ihe.gazelle.assertion-manager.CoveredAssertions']}
                            </ui:define>
                            <h:outputLink
                                    title="#{scopeCoverage.scope.keyword} #{messages['net.ihe.gazelle.assertion-manager.CoveredAssertions_2']}"
                                    rendered="#{scopeCoverage.isDisplayActions()}"
                                    value="#{request.contextPath}/assertions/index.seam">
                                <f:param name="scope" value="#{scopeCoverage.scope.keyword}"/>
                                <f:param name="coveredCheckboxes" value="ANY"/>
                                <h:outputText
                                        value="#{scopeCoverage.nbAssertionsCovered} (#{scopeCoverage.getPercentCovered()}%)"/>
                            </h:outputLink>
                            <h:outputText
                                    value="#{scopeCoverage.nbAssertionsCovered} (#{scopeCoverage.getPercentCovered()}%)"
                                    rendered="#{!scopeCoverage.isDisplayActions()}"/>
                        </g:column>

                        <g:column>
                            <ui:define name="header">
                                #{messages['net.ihe.gazelle.assertion-manager.NotCoveredAssertions']}
                            </ui:define>
                            <h:outputLink
                                    title="#{scopeCoverage.scope.keyword} #{messages['net.ihe.gazelle.assertion-manager.NotCoveredAssertions']}"
                                    rendered="#{scopeCoverage.isDisplayActions()}"
                                    value="#{request.contextPath}/assertions/index.seam">
                                <f:param name="scope" value="#{scopeCoverage.scope.keyword}"/>
                                <f:param name="notCoveredCheckboxes" value="ANY"/>
                                <h:outputText
                                        value="#{scopeCoverage.nbAssertionsNotCovered} (#{scopeCoverage.getPercentNotCovered()}%)"/>
                            </h:outputLink>
                            <h:outputText
                                    value="#{scopeCoverage.nbAssertionsNotCovered} (#{scopeCoverage.getPercentNotCovered()}%)"
                                    rendered="#{!scopeCoverage.isDisplayActions()}"/>
                        </g:column>

                        <g:column rendered="#{s:hasRole('admin_role')}">
                            <ui:define name="header">#{messages['net.ihe.gazelle.assertion-manager.Progress']}
                            </ui:define>
                            <div class="progress" style="margin-bottom: 0;">
                                <div class="progress-bar progress-bar-success"
                                     style="width: #{scopeCoverage.getPercentCovered()}%;">
                                    <span title="covered">
                                        <h:outputText
                                                value="#{scopeCoverage.getPercentCovered()}%"/>
                                    </span>
                                </div>
                                <div class="progress-bar progress-bar-danger"
                                     style="width: #{scopeCoverage.getPercentNotCovered()}%;">
                                    <span title="not covered">
                                        <h:outputText
                                                value="#{scopeCoverage.getPercentNotCovered()}%"/>
                                    </span>
                                </div>
                            </div>
                        </g:column>
                        <g:column id="actionsColumn">
                            <ui:define name="header">#{messages['users.Action']}</ui:define>
                            <h:panelGroup styleClass="gzl-never-wrap" rendered="#{scopeCoverage.isDisplayActions()}">
                                <h:outputLink
                                        title="#{messages['net.ihe.gazelle.assertion-manager.View']}"
                                        value="show.seam">
                                    <f:param name="show" value="#{scopeCoverage.scope.id}"/>
                                    <span class="gzl-icon-search"/>
                                </h:outputLink>
                                <h:outputLink title="#{messages['users.Edit']}" value="edit.seam"
                                              rendered="#{s:hasRole('admin_role')}">
                                    <f:param name="id" value="#{scopeCoverage.scope.id}"/>
                                    <span class="gzl-icon-pencil"/>
                                </h:outputLink>
                                <a4j:commandLink event="click"
                                                 title="#{messages['users.Delete']}"
                                                 rendered="#{assertionScopeManager.getAssertionsScopesReferencingSize(scopeCoverage.scope) eq 0 and s:hasRole('admin_role')}"
                                                 oncomplete="jq162('#DeleteConfirmationModalPanel').modal('show');"
                                                 render="deleteDocumentForm,globalform"
                                                 actionListener="#{assertionScopeManager.setSelectedScope(scopeCoverage.scope)}">
                                    <span class="gzl-icon-trash-o"/>
                                </a4j:commandLink>

                                <a4j:commandLink event="click"
                                                 title="#{messages['users.Delete']}"
                                                 rendered="#{assertionScopeManager.getAssertionsScopesReferencingSize(scopeCoverage.scope) gt 0 and s:hasRole('admin_role')}"
                                                 oncomplete="jq162('#DeleteConfirmationModalPanel').modal('show');"
                                                 render="deleteDocumentForm"
                                                 actionListener="#{assertionScopeManager.setSelectedScope(scopeCoverage.scope)}">
                                    <span class="gzl-icon-trash-o gzl-color-light-grey"/>
                                </a4j:commandLink>
                            </h:panelGroup>
                        </g:column>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="scopeTableDs"/>
                                <ui:param name="dataTableId" value="scopeTable"/>
                                <ui:param name="hideRowsSelect" value="true"/>
                                <ui:param name="maxPages" value="5"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                </div>
            </div>
        </h:form>

        <h:form id="deleteDocumentForm">
            <s:token allowMultiplePosts="true"/>
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="DeleteConfirmationModalPanel"/>
                <ui:define name="popup_title">
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.assertion-manager.ConfirmDelete']}"/>
                </ui:define>
                <s:div
                        rendered="#{assertionScopeManager.getAssertionsScopesReferencing(assertionScopeManager.getSelectedScope()).size eq 0}">
                    <h:outputText id="cannotDeleteScope_OutputText"
                                  value="#{messages['net.ihe.gazelle.assertion-manager.DoYouReallyWantToDeleteThisScope']} #{assertionScopeManager.getSelectedScope().getKeyword()}?"/>
                </s:div>
                <s:div
                        rendered="#{assertionScopeManager.getAssertionsScopesReferencing(assertionScopeManager.getSelectedScope()).size gt 0}">
                    <h:outputText id="deleteScope_OutputText"
                                  value="#{messages['net.ihe.gazelle.assertion-manager.TheScope']} #{assertionScopeManager.getSelectedScope().getKeyword()} #{messages['net.ihe.gazelle.assertion-manager.CannotBeDeletedBecauseItIsReferencedByThoseScope']}"/>
                    <ul>
                        <a4j:repeat
                                value="#{assertionScopeManager.getAssertionsScopesReferencing(assertionScopeManager.getSelectedScope())}"
                                var="scopeRef">
                            <li>
                                <h:outputLink id="scope" target="_blank"
                                              value="show.seam">
                                    <f:param name="show" value="#{scopeRef.id}"/>
                                    <h:outputText value="#{scopeRef.keyword}"/>
                                </h:outputLink>
                            </li>
                        </a4j:repeat>
                    </ul>
                </s:div>
                <ui:define name="popup_footer">
                    <h:commandButton value="#{messages['users.Cancel']}"
                                     styleClass="gzl-btn"
                                     onclick="jq162('#DeleteConfirmationModalPanel').modal('hide');"/>
                    <h:commandButton value="#{messages['users.Delete']}"
                                     rendered="#{assertionScopeManager.getAssertionsScopesReferencing(assertionScopeManager.getSelectedScope()).size eq 0}"
                                     action="#{assertionScopeManager.delete()}"
                                     styleClass="gzl-btn-red"
                                     onclick="jq162('#DeleteConfirmationModalPanel').modal('hide');"/>

                </ui:define>
            </ui:decorate>
        </h:form>
    </ui:define>
</ui:composition>
